=begin
___________________________________________________________________________
(c) TIG 2010
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
___________________________________________________________________________
  antiprism.rb >>> Plugins Folder
___________________________________________________________________________
Usage:
  Tool to make an 'Antiprism'.
  Type into Ruby Console:
    antiprism number_of_sides, length_of_a_side
  e.g. antiprism(3, 1.m)
  It is grouped and made centered at the origin.
  It is named 'Antiprism[3x1.000]'.
___________________________________________________________________________
Donations:
by PayPal to info @ revitrev.org
___________________________________________________________________________
Version:
1.0 20101113 First Release.
1.1 20101114 PI glitch fixed.
___________________________________________________________________________
=end
###
require 'sketchup.rb'
###
def antiprism(n=4, l=1.0)
  ### number of sides
  n = n.to_i
  n = 3 if n < 3
  ### length of a side
  a = l.to_f
  a = 1.0 if a <= 0.0
  ###
  pi = Math::PI
  s = (Math.tan(pi / (2 * n))) * a / 2 # sagitta
  p = a * Math.sin(pi / 3) # hypotenhuse
  h = Math.sqrt(p**2 - s**2) # height between faces
  r = a / (2 * Math.sin(pi / n)) # radius of enclosing circle
  ###
  model=Sketchup.active_model
  ###
  model.start_operation("Antiprism")
  ###
  ents=model.active_entities
  group=ents.add_group()
  gents=group.entities
  bedges=gents.add_ngon(ORIGIN, Z_AXIS, r, n)
  tedges=gents.add_ngon(ORIGIN+[0,0,h], Z_AXIS, r, n)
  tr=Geom::Transformation.rotation(ORIGIN, Z_AXIS, (2 * pi / n)/2)
  gents.transform_entities(tr, tedges)
  bface=gents.add_face(bedges)
  tface=gents.add_face(tedges)
  bedges[0].explode_curve
  tedges[0].explode_curve
  ###
  0.upto(n-1){|i|
    gents.add_face(bedges[i].start.position, bedges[i].end.position, tedges[i].start.position)
    gents.add_face(tedges[i].start.position, tedges[i].end.position, bedges[i].end.position)
  }
  ###
  group.name="Antiprism["+n.to_s+"x"+l.to_s+"]"
  ###
  model.commit_operation
  ###
end#def
###